do
	local super=TRAININGGROUNDS_Mobile
	TRAININGGROUNDS_OPULENCE_Mobile_MinibossFlames=TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_OPULENCE_Mobile_MinibossFlames
	

	function class:GetName()
		--override, don't call super
		return "OpulenceMinibossFlames (mobile) "..tostring(self.id)
	end
	
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.basemovespeed = 1.5 * TRAININGGROUNDS_Mobile_ConvertYardsToTGUnits(7.0)
		self.hitboxradius=TRAININGGROUNDS_Mobile_StandardHitboxRadius*10.0
		--self.hitboxradius=TRAININGGROUNDS_Mobile_StandardHitboxRadius*4.0
		--self.hitboxradius=TRAININGGROUNDS_Mobile_StandardHitboxRadius*3.0
		self.baseturnspeed=2.0	--TODO: only during FlamesOfPunishment
		self.baseturnspeed_3D=2.0	--TODO: only during FlamesOfPunishment		
	end
	
	function class:CreateAI()
		self.ai=TRAININGGROUNDS_AI_Boss.new()
		self.ai:Setup(self,environment)
	end		
	
	function class:SetDrawable()
		self.drawable=TRAININGGROUNDS_OPULENCE_Drawable_MinibossFlames.new()
		self.drawable:Setup(self,self.environment)
	end
	
	-- function class:CreateCombatModule()
		-- self.combat=TRAININGGROUNDS_OPULENCE_CombatModule_MinibossFlames.new()
		-- self.combat:Setup(self)
	-- end
end

do
	--TODO: move to content/aggramar
	TRAININGGROUNDS_OPULENCE_ANIMATION_LIST={}


	local stand=TRAININGGROUNDS_AnimationSequence_QuickSetup(TRAININGGROUNDS_OPULENCE_ANIMATION_LIST,"Stand",0,nil,TRAININGGROUNDS_ANIMATION_PRIORITY.TELEGRAPH,nil)	
	local stance=TRAININGGROUNDS_AnimationSequence_QuickSetup(TRAININGGROUNDS_OPULENCE_ANIMATION_LIST,"Stance",51,nil,TRAININGGROUNDS_ANIMATION_PRIORITY.TELEGRAPH,nil)
	local loop=TRAININGGROUNDS_AnimationSequence_QuickSetup(TRAININGGROUNDS_OPULENCE_ANIMATION_LIST,"FlamesOfPunishment",125,nil,TRAININGGROUNDS_ANIMATION_PRIORITY.TELEGRAPH,nil)
	


	if(not TRAININGGROUNDS_ModelInfos.OpulenceMinibossFlames)then
		local mi
		mi=TRAININGGROUNDS_ModelInfo.new()
		mi:Setup()
		mi.displayid=80311
		mi.cameradistance=80
		mi.size=500
		mi.shadowsize=mi.size*0.33
		
		mi.clickboxx=0
		mi.clickboxy=-5
		mi.clickboxwidth=32
		mi.clickboxheight=52
		
		TRAININGGROUNDS_ModelInfos.OpulenceMinibossFlames=mi
		TRAININGGROUNDS_ModelInfos:Add(mi.displayid,mi)
	end

	local super=TRAININGGROUNDS_Drawable_CharacterModel
	TRAININGGROUNDS_OPULENCE_Drawable_MinibossFlames = TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_OPULENCE_Drawable_MinibossFlames 
	
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.scale3D=1.5	--TODO: move to modelinfo
		--self.positionmultiplier=0.9
		self.positionmultiplier=1/self.scale3D
	end
	
	function class:SetFrameAppearance()	
		self.modelinfo=TRAININGGROUNDS_ModelInfos.OpulenceMinibossFlames
		self.frame:SetDisplayInfo(self.modelinfo.displayid)	
	end
	
	function class:Get3DPositionCoords()
		local yard=TRAININGGROUNDS_Mobile_ConvertYardsToTGUnits(1)
		return self.x,self.y,self.z+yard*0.25
	end
end
