

do
	local super=TRAININGGROUNDS_Scenario
	TRAININGGROUNDS_OPULENCE_Scenario_FlamesOfPunishment = TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_OPULENCE_Scenario_FlamesOfPunishment

	function class:Populate()
		super.Populate(self)				
			
		self:CreateBossController()
		
		local currentplayer=self.raid.rdps[1]
		self.controls:SetPlayer(currentplayer)
		currentplayer:SetPlayerAppearance()
		local relevant=TRAININGGROUNDS_Aura_PlayerControlled.new()
		relevant:Setup(currentplayer.combat,currentplayer.combat,currentplayer:GetLocalTime())			

		self.flamesofpunishment.groupdancemodule:GetIntoInitialPosition()
		
		--local YDIFF=100
		local XDIFF=125
		local YDIFF=0
		
		self.startbuttons={}
		--!!!
		local startbutton	
		startbutton=TRAININGGROUNDS_Button.new()
		startbutton:Setup(self.environment.game.environment_hud)
		startbutton.x=self.environment.game.window.frame:GetWidth()/2-XDIFF*2.7
		startbutton.y=self.environment.game.window.frame:GetHeight()/2-200+YDIFF
		startbutton.drawable.width=200;startbutton.drawable.height=140				
		startbutton:SetText("Heroic")
		startbutton.drawable.frame:SetScript("OnClick",function()
					self.flamesofpunishment.groupdancemodule.mode_choice=1
					self.flamesofpunishment.groupdancemodule.cast_time=4.0
					self.flamesofpunishment.groupdancemodule.channel_time=6.5
					self.flamesofpunishment.groupdancemodule.total_ticks=12
					self.flamesofpunishment.groupdancemodule.conewidth=math.pi*2/6
					self.flamesofpunishment.groupdancemodule.flamecount=1
					self.flamesofpunishment.groupdancemodule.spin_per_tick=math.pi*2/12
					self.flamesofpunishment.groupdancemodule.turnspeed=2.0
					self:OnStartButton()
				end)
		tinsert(self.startbuttons,startbutton)
		local startbutton	
		startbutton=TRAININGGROUNDS_Button.new()
		startbutton:Setup(self.environment.game.environment_hud)
		startbutton.x=self.environment.game.window.frame:GetWidth()/2-XDIFF
		startbutton.y=self.environment.game.window.frame:GetHeight()/2-200+YDIFF
		startbutton.drawable.width=200;startbutton.drawable.height=140				
		startbutton:SetText("Heroic\r(Overload)")
		startbutton.drawable.frame:SetScript("OnClick",function()					
					self.flamesofpunishment.groupdancemodule.mode_choice=2
					self.flamesofpunishment.groupdancemodule.cast_time=3.0
					self.flamesofpunishment.groupdancemodule.channel_time=6.5
					self.flamesofpunishment.groupdancemodule.total_ticks=12
					self.flamesofpunishment.groupdancemodule.conewidth=math.pi*2/2
					self.flamesofpunishment.groupdancemodule.flamecount=3
					self.flamesofpunishment.groupdancemodule.spin_per_tick=math.pi*2/12		
					self.flamesofpunishment.groupdancemodule.turnspeed=2.0					
					self:OnStartButton()
				end)
		tinsert(self.startbuttons,startbutton)		
		local startbutton	
		startbutton=TRAININGGROUNDS_Button.new()
		startbutton:Setup(self.environment.game.environment_hud)
		startbutton.x=self.environment.game.window.frame:GetWidth()/2+XDIFF
		startbutton.y=self.environment.game.window.frame:GetHeight()/2-200-YDIFF
		startbutton.drawable.width=200;startbutton.drawable.height=140				
		startbutton:SetText("Mythic")
		startbutton.drawable.frame:SetScript("OnClick",function()
					self.flamesofpunishment.groupdancemodule.mode_choice=3
					self.flamesofpunishment.groupdancemodule.cast_time=4.0
					self.flamesofpunishment.groupdancemodule.channel_time=6.5
					self.flamesofpunishment.groupdancemodule.total_ticks=11
					self.flamesofpunishment.groupdancemodule.conewidth=math.pi*2/6
					self.flamesofpunishment.groupdancemodule.flamecount=1
					self.flamesofpunishment.groupdancemodule.spin_per_tick=math.pi*2/7*(1.0) --TODO: 0.95 or similar
					self.flamesofpunishment.groupdancemodule.turnspeed=4.0
					self:OnStartButton()
				end)
		tinsert(self.startbuttons,startbutton)		

		local startbutton	
		startbutton=TRAININGGROUNDS_Button.new()
		startbutton:Setup(self.environment.game.environment_hud)
		startbutton.x=self.environment.game.window.frame:GetWidth()/2+XDIFF*2.7
		startbutton.y=self.environment.game.window.frame:GetHeight()/2-200-YDIFF
		startbutton.drawable.width=200;startbutton.drawable.height=140				
		startbutton:SetText("Mythic\r(Overload)")
		startbutton.drawable.frame:SetScript("OnClick",function()
					self.flamesofpunishment.groupdancemodule.mode_choice=4
					self.flamesofpunishment.groupdancemodule.cast_time=4.0
					self.flamesofpunishment.groupdancemodule.channel_time=6.5
					self.flamesofpunishment.groupdancemodule.total_ticks=11
					self.flamesofpunishment.groupdancemodule.conewidth=math.pi*2/2
					self.flamesofpunishment.groupdancemodule.flamecount=3
					self.flamesofpunishment.groupdancemodule.spin_per_tick=math.pi*2/7*(1.0) --TODO: 0.95 or similar		
					self.flamesofpunishment.groupdancemodule.turnspeed=4.0					
					self:OnStartButton()
				end)
		tinsert(self.startbuttons,startbutton)				

	end

	function class:SetCamera()
		self.environment.game.environment_gameplay.cameramanager.camera=TRAININGGROUNDS_Camera3D.new()
		self.environment.game.environment_gameplay.cameramanager.camera:Setup(self.environment.game.environment_gameplay)
	end	

	--TODO: somehow connect camera+playercontrols, since they're usually codependent
	function class:CreatePlayerControls()
		local controls = TRAININGGROUNDS_ScenarioPlayerControls_CharacterMode_3D.new()
		controls:Setup(self.environment,self)			
		self.controls=controls
	end
	
	function class:CreateBossController()
		self.flamesofpunishment=TRAININGGROUNDS_OPULENCE_BossController_FlamesOfPunishment.new()
		--TODO: at this point it becomes very awkward that scenario.environment is not scenario.environment_gameplay
		self.flamesofpunishment:Setup(self.environment.game.environment_gameplay,self)
		self.flamesofpunishment:CreateBoss()		
		self.flamesofpunishment.groupdancemodule.bosscontroller=self.flamesofpunishment
		self.flamesofpunishment.groupdancemodule:PopulateDefaultRaid(self.environment.game.environment_gameplay)
	end
	
	function class:OnStartButton()
		for i=1,#self.startbuttons do
			self.startbuttons[i].visible=false	
			self.startbuttons[i].drawable.frame:EnableMouse(false)
		end
		self.flamesofpunishment.groupdancemodule:StartTestCycle()
	end
	
	function class:ShowButtons()
		for i=1,#self.startbuttons do
			self.startbuttons[i].visible=true	
			self.startbuttons[i].drawable.frame:EnableMouse(true)
		end	
	end

	function class:OnEscapeKey()
		self.environment.game:LoadScenarioByClass(TRAININGGROUNDS_Scenario_Menu)
	end
	
	
	
end
