do
	local super=TRAININGGROUNDS_Mobile
	TRAININGGROUNDS_VECTIS_Mobile_Vectis=TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_VECTIS_Mobile_Vectis
	

	function class:GetName()
		--override, don't call super
		return "Vectis (mobile) "..tostring(self.id)
	end
	
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		
		self.faction=TRAININGGROUNDS_Factions.ENEMY
		
		self.basemovespeed = 1.5 * TRAININGGROUNDS_Mobile_ConvertYardsToTGUnits(7.0)
		self.hitboxradius=TRAININGGROUNDS_Mobile_StandardHitboxRadius*10.0
		--self.hitboxradius=TRAININGGROUNDS_Mobile_StandardHitboxRadius*4.0
		--self.hitboxradius=TRAININGGROUNDS_Mobile_StandardHitboxRadius*3.0
	end
	
	function class:CreateAI()
		self.ai=TRAININGGROUNDS_AI_Boss.new()
		self.ai:Setup(self,environment)
	end		
	
	function class:SetDrawable()
		self.drawable=TRAININGGROUNDS_VECTIS_Drawable_Vectis.new()
		self.drawable:Setup(self,self.environment)
	end
	
	function class:CreateCombatModule()
		self.combat=TRAININGGROUNDS_VECTIS_CombatModule_Vectis.new()
		self.combat:Setup(self)
	end


	
end