
do
	local super=TRAININGGROUNDS_Scenario
	TRAININGGROUNDS_VECTIS_Scenario_Vectis = TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_VECTIS_Scenario_Vectis

	function class:Populate()
		super.Populate(self)				
			
			
		--TODO: RaidMarkerController should be in baseline scenario class	
		local wmcontroller=TRAININGGROUNDS_RaidMarkerController.new()
		wmcontroller:Setup(self.environment.game.environment_gameplay)
		self.wmcontroller=wmcontroller

		local platformsize=TRAININGGROUNDS_Mobile_ConvertYardsToTGUnits(50)
		
		--TODO: arenaborder should be in baseline scenario class
		local bigcircle=TRAININGGROUNDS_BigCircle.new()
		bigcircle:Setup(self.environment.game.environment_gameplay)
		bigcircle.drawable.width=platformsize+20
		bigcircle.drawable.height=platformsize+20
		bigcircle.x=0
		bigcircle.y=0
		bigcircle.drawable:SetColor(1,1,1,1)
		
		local bigcircle=TRAININGGROUNDS_BigCircle.new()
		bigcircle:Setup(self.environment.game.environment_gameplay)
		bigcircle.drawable.width=platformsize
		bigcircle.drawable.height=platformsize
		bigcircle.x=0
		bigcircle.y=0	
		bigcircle.drawable:SetColor(.1,.1,.1,1)
		
		
		-- --!!!
		-- local testarrow=TRAININGGROUNDS_Telegraph_MovementArrow.new()
		-- testarrow:Setup(self.environment.game.environment_gameplay)
		-- --TODO: should testarrow itself have SetArrow which calls drawable:SetArrow?
				-- -- (in a perfectly encapsulated world, the answer is obviously yes)
		-- testarrow.drawable:SetColor(0,1,1,1)
		-- testarrow.drawable:SetArrow(0,0,100,0,10,20)
		-- testarrow.visible=true
		-- testarrow.drawable.visible=true
		-- --TRAININGGROUNDS_FrameVisibilityCheck(testarrow.drawable.frame)
		

		-- local testarrow=TRAININGGROUNDS_Telegraph_MovementArrow.new()
		-- testarrow:Setup(self.environment.game.environment_gameplay)
		-- --TODO: should testarrow itself have SetArrow which calls drawable:SetArrow?
				-- -- (in a perfectly encapsulated world, the answer is obviously yes)
		-- testarrow.drawable:SetColor(0,1,1,1)
		-- testarrow.drawable:SetArrow(-300,0,100,0,20,20)
		-- --TRAININGGROUNDS_FrameVisibilityCheck(testarrow.drawable.frame)
		-- TEST_GLOBAL=testarrow
		-- --/run TRAININGGROUNDS_FrameVisibilityCheck(TEST_GLOBAL.drawable.frame)
				
		
		
		--TODO: maybe don't show healthbar until combat starts?
		local bosstitlebar=TRAININGGROUNDS_BossTitleBar.new()
		bosstitlebar:Setup(self.environment.game.environment_hud)
		bosstitlebar.x=self.environment.game.SCREEN_WIDTH/2
		bosstitlebar.y=self.environment.game.SCREEN_HEIGHT-60
		--bosstitlebar.drawable.width=self.environment.game.SCREEN_WIDTH;bosstitlebar.drawable.height=60
		bosstitlebar.drawable.width=400;bosstitlebar.drawable.height=60
		
		
	
		-- local telegraph=TRAININGGROUNDS_Telegraph_Polygon.new()
		-- telegraph:Setup(self.environment.game.environment_gameplay)		
		-- local x1=0
		-- local y1=0
		-- telegraph.x=x1
		-- telegraph.y=y1
		-- telegraph:SetColor(1,0,0,1)
		-- telegraph:SetVertices(0,0,100,0,0,100)

		
		
		
		self:CreateBossController()
		
		
		local currentplayer=self.raid.rdps[1]
		self.controls:SetPlayer(currentplayer)
		currentplayer:SetPlayerAppearance()
		local relevant=TRAININGGROUNDS_Aura_PlayerControlled.new()
		relevant:Setup(currentplayer.combat,currentplayer.combat,currentplayer:GetLocalTime())			

		self.vectis.groupdancemodule:GetIntoInitialPosition()
		
		

		
		
		self.startbuttons={}
		--!!!
		local startbutton
		startbutton=TRAININGGROUNDS_Button.new()
		startbutton:Setup(self.environment.game.environment_hud)
		startbutton.x=self.environment.game.window.frame:GetWidth()/2-0
		startbutton.y=self.environment.game.window.frame:GetHeight()/2
		startbutton.drawable.width=200;startbutton.drawable.height=140
		startbutton:SetText("All phases")
		startbutton.drawable.frame:SetScript("OnClick",function()
					self.vectis.groupdancemodule.playeroddoreven_choice=1									
					self:OnStartButton()
				end)
		tinsert(self.startbuttons,startbutton)
		
		startbutton=TRAININGGROUNDS_Button.new()
		startbutton:Setup(self.environment.game.environment_hud)
		startbutton.x=self.environment.game.window.frame:GetWidth()/2-125
		startbutton.y=self.environment.game.window.frame:GetHeight()/2-200
		startbutton.drawable.width=200;startbutton.drawable.height=140				
		startbutton:SetText("Phase 1 only")
		startbutton.drawable.frame:SetScript("OnClick",function()
					self.vectis.groupdancemodule.playeroddoreven_choice=2									
					self:OnStartButton()
				end)
		tinsert(self.startbuttons,startbutton)

				startbutton=TRAININGGROUNDS_Button.new()
		startbutton:Setup(self.environment.game.environment_hud)
		startbutton.x=self.environment.game.window.frame:GetWidth()/2+125
		startbutton.y=self.environment.game.window.frame:GetHeight()/2-200
		startbutton.drawable.width=200;startbutton.drawable.height=140				
		startbutton:SetText("Phase 2 only")
		startbutton.drawable.frame:SetScript("OnClick",function()
					self.vectis.groupdancemodule.playeroddoreven_choice=2									
					self:OnStartButton()
				end)
		tinsert(self.startbuttons,startbutton)

		
		
		--dubious
		self.vectis.groupdancemodule:StartDancing()
	end
	
	function class:CreateBossController()
		self.vectis=TRAININGGROUNDS_VECTIS_BossController_Vectis.new()
		--TODO: at this point it becomes very awkward that scenario.environment is not scenario.environment_gameplay
		self.vectis:Setup(self.environment.game.environment_gameplay,self)
		self.vectis:CreateBoss()		
		self.vectis.groupdancemodule.bosscontroller=self.vectis
		self.vectis.groupdancemodule:PopulateDefaultRaid(self.environment.game.environment_gameplay)
	end
	
	function class:OnStartButton()
		for i=1,#self.startbuttons do
			self.startbuttons[i].visible=false	
			self.startbuttons[i].drawable.frame:EnableMouse(false)
		end
		self.vectis.groupdancemodule:StartTestCycle()
	end

	--phase3all scenario inherits this one, so we only have to write this function once here:
	function class:OnEscapeKey()
		--TODO: cancelcountdown properly
		TRAININGGROUNDS_FakeDBM_CancelCountdown(DBM)
		self.environment.game:LoadScenarioByClass(TRAININGGROUNDS_Scenario_Menu)
	end
	
end