--TODO: where is this used, and do we need to source it?
function TRAININGGROUNDS_Transform_Rotate2D(x,y,angle,originx,originy)
	local x1=x-originx
	local y1=y-originy
	local x2=x1*math.cos(angle)-y1*math.sin(angle)
	local y2=y1*math.cos(angle)+x1*math.sin(angle)
	x2=x2+originx
	y2=y2+originy

	return x2,y2
end


function TRAININGGROUNDS_QuadraticFormula(a,b,c)
	local x1=(-b + math.sqrt(b*b-4*a*c))/(2*a)
	local x2=(-b - math.sqrt(b*b-4*a*c))/(2*a)
	return x1,x2
end



function TRAININGGROUNDS_MatrixMultiplicationRotation(x,y,z,ax,ay,az)
	local x2=x
	local y2=y
	local z2=z

													
	x2,y2,z2=TRAININGGROUNDS_MatrixMultiplication(x2,y2,z2,
										math.cos(az),-math.sin(az),0,
										math.sin(az),math.cos(az),0,
										0,0,1)		
	x2,y2,z2=TRAININGGROUNDS_MatrixMultiplication(x2,y2,z2,
										1,0,0,
										0,math.cos(ax),-math.sin(ax),
										0,math.sin(ax),math.cos(ax))
	x2,y2,z2=TRAININGGROUNDS_MatrixMultiplication(x2,y2,z2,
										math.cos(ay),0,math.sin(ay),
										0,1,0,
										-math.sin(ay),0,math.cos(ay))
	return x2,y2,z2
end

function TRAININGGROUNDS_MatrixMultiplication(x,y,z,a00,a10,a20,a01,a11,a21,a02,a12,a22)
	local x2,y2,z2
	x2=x*a00+y*a10+z*a20
	y2=x*a01+y*a11+z*a21
	z2=x*a02+y*a12+z*a22
	return x2,y2,z2
end