_TRAININGGROUNDS_ReusableModelFrames = TRAININGGROUNDS_inheritsFrom(_TRAININGGROUNDS_ReusableFrames)

TRAININGGROUNDS_ReusableModelFrames=_TRAININGGROUNDS_ReusableModelFrames.new()
TRAININGGROUNDS_ReusableModelFrames.inactiveframes={}
TRAININGGROUNDS_ReusableModelFrames.activeframes={}
TRAININGGROUNDS_ReusableModelFrames.nextframeid=0

function _TRAININGGROUNDS_ReusableModelFrames:NextFrameName()	
	return "TRAININGGROUNDS_ReusableModelFrame"..tostring(self.nextframeid);
end



function _TRAININGGROUNDS_ReusableModelFrames:ReturnCreateFrameDetails(framename)
	return CreateFrame("DressUpModel",framename,UIParent)
	--return CreateFrame("PlayerModel",framename,UIParent)
end

-- 
--frame:SetCamera(0) -- full view (i.e. not facecam)

function _TRAININGGROUNDS_ReusableModelFrames:ResetProperties(f)	
	TRAININGGROUNDS_ReusableFrames.ResetProperties(self,f)
	f:SetCamera(1)
	f:SetPosition(0,0,0)
	f:SetRotation(0)
	f:SetModelScale(1)
	f:SetModelAlpha(1)
	f:SetDesaturation(0.0)
	
end