
do
	--TODO: we can currently get away with this because Aggramar waits 1.0 sec between attacks
		-- but in future, we need to properly STUN the target tank
	local super=TRAININGGROUNDS_Aura
	TRAININGGROUNDS_AGGRAMAR_Aura_SearingBinding=TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_AGGRAMAR_Aura_SearingBinding
	
	
	
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		--TODO: base duration should be 5.0 (and dispelled early)
		self.baseduration=1.0
	end
	
	function class:OnApply(combattime)
		local targetmobile=self.targetcombat.owner
		local telegraph=TRAININGGROUNDS_Telegraph_BigThinCircle_Flash.new()
		-- we're cheating here; mob isn't being stunned properly so we save their initial position
		self.x=targetmobile.x
		self.y=targetmobile.y
		telegraph:Setup(targetmobile.environment)		
		telegraph.x=self.x
		telegraph.y=self.y
			--TODO: nil expiry, but vanish when castercombat stops casting
				-- can't use caststarttime as castercombat's localtime is different from environment's
		telegraph.expirytime=targetmobile.environment.localtime+1.0
		telegraph.flashperiod=0.3
		telegraph:SetColor(0.5,0.5,0,1)
		telegraph:ChangeFrameLayer(targetmobile.environment.cameramanager.camera.voidzoneframelayer)
		
		telegraph:SetRadius(TRAININGGROUNDS_Mobile_ConvertYardsToTGUnits(20))	--TODO: fix magic number		
	end
	
	--TODO: should be OnRemove, but nothing calls OnRemove yet
	function class:OnExpiry()
		-- TODO: for various reasons, we don't have a Spell_SearingBindingsProc yet
		local targetmobile=self.targetcombat.owner		
		local telegraph=TRAININGGROUNDS_Telegraph_Circle_FlashOnce.new()
		telegraph:Setup(targetmobile.environment)		
		local x1=self.x
		local y1=self.y		
		telegraph.x=x1
		telegraph.y=y1	
		telegraph:SetColor(1,0,0,1)
		telegraph:SetRadius(TRAININGGROUNDS_Mobile_ConvertYardsToTGUnits(20))	--TODO: fix magic number
		
		local players=TRAININGGROUNDS_GetAllObjectsInCircle(
			self.castercombat.owner.environment.mobiles,
			x1,y1,TRAININGGROUNDS_Mobile_ConvertYardsToTGUnits(20))
		
		--print("Checking for players within radius",x1,y1)
		--print("Found",#players)
		for i=1,#players do			
			if(players[i]~=targetmobile)then
				--TODO: subject should preferably be SearingBindingsProc, but we can't implement that spell yet
				self.castercombat.combatlog:RecordEvent({
								action=TRAININGGROUNDS_CombatEventType.HIT_BY_ATTACK,
								subject=self:Class(),
								target=players[i].combat
								})
			end
		end
	end
end