

do

	local yard=TRAININGGROUNDS_Mobile_ConvertYardsToTGUnits(1)
	local REDX="\124TInterface\\TargetingFrame\\UI-RaidTargetingIcon_7:12\124t"
	local INTRO_TIME_MULTIPLIER=1.0
--local INTRO_TIME_MULTIPLIER=0.1
	--local CENTERCIRCLE_HEIGHT=0
	local CENTERCIRCLE_HEIGHT=1*yard
	local PLAYER_DISTANCE=yard*22

	TRAININGGROUNDS_JADEFIREMASTERS_CustomDanceEventType={}
	local i=0
	i=i+1;TRAININGGROUNDS_JADEFIREMASTERS_CustomDanceEventType.SUCCESS=i
	i=i+1;TRAININGGROUNDS_JADEFIREMASTERS_CustomDanceEventType.MISS=i

	
	local super=TRAININGGROUNDS_GroupDanceModule	
	TRAININGGROUNDS_JADEFIREMASTERS_GroupDanceModule_MultiSidedStrike=TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_JADEFIREMASTERS_GroupDanceModule_MultiSidedStrike
	
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.successesinarow=0
		self.soloorgroup_choice=nil
		self.playercount=1
		self.successes=0		
		self.angles={}
		for i=1,7 do
			self.angles[i]={}
		end
		self.clonecounter=0
	end

	--SOURCE: www.programming-idioms.org/idiom/10/shuffle-a-list/.../lua
	local shuffle=function(list)
		local shuffledlist={}
		for i,v in ipairs(list) do
			local pos=math.random(1,#shuffledlist+1)
			table.insert(shuffledlist,pos,v)
		end
		return shuffledlist
	end

	
	function class:PopulateDefaultRaid(environment)	
		self.environment=environment
		
		self.raid:CreatePlayers(environment,0,0,0,1)		
		--self.raid:MakeAllPlayersIrrelevant()
		
		-- for now, no autoattacks.
		for i=1,#self.raid.players do
			self.raid.players[i].combat.autoattackmodule:Cleanup()
			self.raid.players[i].combat.autoattackmodule=nil
		end
	
		--TODO: move raid roles to another function
		self.tanks=self.raid.tanks
		self.currenttankindex=1
		self.rdps=self.raid.rdps
		self.player=self.raid.rdps[1]
		self.raid.players[1].x=0
		self.raid.players[1].y=0				
		
		self.centercircles={}
		

		
		-- local skybox=TRAININGGROUNDS_JADEFIREMASTERS_Decor_JadefireSkybox.new()
		-- skybox:Setup(environment)
		-- skybox.x=0;skybox.y=0;skybox.z=0


		
		--TODO: set self.wmcontroller during setup
		self.wmcontroller=self.scenario.wmcontroller
		local wmcontroller=self.wmcontroller
							
		self:SetupInitialCameraFocus()
	end
	
	--TODO: maybe baseline, maybe not
	function class:SetupInitialCameraFocus()
		local camera=self.player.environment.cameramanager.camera
		tinsert(camera.focus,self.player)
	end

	
	function class:GetIntoInitialPosition()							
		self.player.x=0
		self.player.y=0
		self.player.currentfacing=-math.pi/2	-- facing "south" for 3D camera
		self.player.currentfacing_3D=self.player.currentfacing
		self.player.targetfacing_3D=self.player.currentfacing_3D
		self.scenario.environment.game.environment_gameplay.cameramanager.camera.cangy=self.player.currentfacing		
	end
	
	function class:StartDancing()
		-- TODO: for some reason we're not using this function when we really should be
	end
	
	function class:StartTestCycle()
		--SOURCE: DBM-Core.lua
		 --TimerTracker_OnEvent(TimerTracker, "PLAYER_ENTERING_WORLD")
		 --TimerTracker_OnEvent(TimerTracker, "START_TIMER", 2, 5, 5)
		
		--if(self.firsttechnique)then self:SoakChoiceMessage() end
		
		--TRAININGGROUNDS_FakeDBM_MinorWarning(DBM,"Multi-Sided Strike!")
		
		if(self.soloorgroup_choice==1)then self.playercount=1 else self.playercount=7 end	
		--print("Playercount:",self.playercount)

		--!!!
		local event=TRAININGGROUNDS_TimedDanceEvent.new()
		event.time=self.scenario.localtime+0.25	--!!!
		event.execute=function() 
			self:ResetPlayerDeathChecks()							
			if(self.soloorgroup_choice==1)then self.playercount=1 else self.playercount=7 end							
			for i=2,self.playercount do
				local newplayer=TRAININGGROUNDS_PlayerCharacter.new()
				newplayer:Setup(self.environment)
				self.raid.players[i]=newplayer
				if(not TRAININGGROUNDS_DEBUG.nonrandomraiderappearance)then newplayer:SetRandomAppearance() end
				newplayer.combat=TRAININGGROUNDS_CombatModule_SampleClass_MDPS.new()
				newplayer.combat:Setup(newplayer)				
				local t=(math.pi*2/6)*(i-2-0.5)
				local x=0+math.cos(t)*PLAYER_DISTANCE
				local y=0+math.sin(t)*PLAYER_DISTANCE								
				self.raid.players[i].x=x;self.raid.players[i].y=y	
		
			end			
			self.clonecounter=0
			for i=1,self.playercount do
				self.angles[i]=shuffle({1,2,3,4,5,6})
			end			
		end
		tinsert(self.timedevents,event)		
		
		local event=TRAININGGROUNDS_TimedDanceEvent.new()
		event.time=self.scenario.localtime+0.5
		event.execute=function() 		
			local iconsize="20"
			local icon="\124Tinterface\\icons\\ability_monk_palmstrike:"..iconsize.."\124t"
			local link="\124cffff0000\124Hspell:290070\124h[Multi-Sided Strike]\124h\124r"			
			local message=icon.."You are being tested with a "..link..", face each attack!"			
			TRAININGGROUNDS_FakeDBM_RaidBossEmote(message,1.0,true)
		end
		tinsert(self.timedevents,event)	

		local event=TRAININGGROUNDS_TimedDanceEvent.new()
		event.time=self.scenario.localtime+1.5	--!!!
		event.execute=function() 			
			local centercircle=TRAININGGROUNDS_JADEFIREMASTERS_Decor_MultiSidedStrikeShadow.new()
			centercircle:Setup(self.environment)
			centercircle.x=0
			centercircle.y=0
			--centercircle.z=0
			centercircle.z=CENTERCIRCLE_HEIGHT
			self.centercircles[1]=centercircle
			for i=2,self.playercount do
				local t=(math.pi*2/6)*(i-2-0.5)
				local x=0+math.cos(t)*PLAYER_DISTANCE
				local y=0+math.sin(t)*PLAYER_DISTANCE								
				-- self.raid.players[i].x=x;self.raid.players[i].y=y	
				local centercircle=TRAININGGROUNDS_JADEFIREMASTERS_Decor_MultiSidedStrikeShadow.new()
				centercircle:Setup(self.environment)
				centercircle.x=x;centercircle.y=y;centercircle.z=CENTERCIRCLE_HEIGHT
				self.centercircles[i]=centercircle				
			end			
			for i=1,self.playercount do
				self.raid.players[i].drawable:SetAnimation(TRAININGGROUNDS_JADEFIREMASTERS_ANIMATION_LIST.MultiSidedStrike_PlayerStance)
			end
		end
		tinsert(self.timedevents,event)			
		
		local nextclone=function()
			self.clonecounter=self.clonecounter+1
			for i=1,self.playercount do
				local angle=(math.pi*2/6)*(self.angles[i][self.clonecounter])
				local DISTANCE=yard*8.75			
				local rdps=self.raid.players[i]
				local flash=TRAININGGROUNDS_JADEFIREMASTERS_Decor_SpawnFlash.new()									
				flash.clonecounter=self.clonecounter
				flash:Setup(self.environment)
				flash.x=rdps.x+math.cos(angle)*DISTANCE;flash.y=rdps.y+math.sin(angle)*DISTANCE
				flash.z=2.5*yard
				local clone=TRAININGGROUNDS_JADEFIREMASTERS_Mobile_FakeMonkBoss.new()									
				clone:Setup(self.environment)
				clone.targetplayer=rdps
				--print("Targetplayer:",rdps,rdps.combat)
				clone.groupdancemodule=self
				clone.clonecounter=self.clonecounter
				--print("Clonecounter:",self.clonecounter)
				clone.angleindex=self.angles[i][self.clonecounter]
				clone.x=rdps.x+math.cos(angle)*DISTANCE;clone.y=rdps.y+math.sin(angle)*DISTANCE	
				clone.targetx=rdps.x
				clone.targety=rdps.y
				clone.z=0
				clone.currentfacing=angle+math.pi
				clone.currentfacing_3D=clone.currentfacing
				clone.targetfacing_3D=clone.currentfacing
				clone:SetGhostAura()
			end
		end
		
		for i=1,5 do
			local event=TRAININGGROUNDS_TimedDanceEvent.new()
			event.time=self.scenario.localtime+1.5+1.0*(i-1)
			event.execute=function()
				nextclone()
			end
			tinsert(self.timedevents,event)	
		end
 
 
		local event=TRAININGGROUNDS_TimedDanceEvent.new()
		event.time=self.scenario.localtime+1.5+9.5
		event.execute=function()
			local message=""
			for i=2,self.playercount do
				self.raid.players[i]:Die()
			end
			if(self.successes>=5)then			
				self.raid.players[1].drawable:SetAnimation(TRAININGGROUNDS_JADEFIREMASTERS_ANIMATION_LIST.MultiSidedStrike_Cheer)
			else				
				self.raid.players[1].drawable:SetAnimation(TRAININGGROUNDS_JADEFIREMASTERS_ANIMATION_LIST.MultiSidedStrike_Knockdown)
			end
			if(self.successes>=5)then
				message="Blocked all 5 attacks!"
			elseif(self.successes>0)then
				message="Blocked "..tostring(self.successes).." out of 5 attacks.  Try again..."
			else
				message="Didn't block any attacks.  Try again..."
			end
			TRAININGGROUNDS_FakeDBM_RaidBossEmote(message,2.0,true)
		end
		tinsert(self.timedevents,event)	 
		
		
		local event=TRAININGGROUNDS_TimedDanceEvent.new()
		event.time=self.scenario.localtime+1.5+9.5+2
		event.execute=function()
			self.scenario:ShowButtons()
		end
		tinsert(self.timedevents,event)	 
	end
	
	
	function class:ResetPlayerDeathChecks()
		self.successes=0
	end
	
	
	function class:Step(elapsed)
		super.Step(self,elapsed)
		
		--print(self.localtime)
		for i=#self.timedevents,1,-1 do
			local event=self.timedevents[i]
			if(self.localtime>=event.time)then	
				event.execute()
				tremove(self.timedevents,i)
			end
		end
	end
		
	function class:ReactToCustomDanceEvent(event)
		-- mobile_fakemonkboss doesn't check whether it's hitting primary player, so check now
		if(event.source~=self.raid.players[1].combat)then return end
		
		--TODO: maybe this should be global (but we'd have to call it "TRAININGGROUNDS_yard" instead)
		local yard=TRAININGGROUNDS_Mobile_ConvertYardsToTGUnits(1)		
	
		-- local targetcombat=event.target
		-- local targetmobile=nil
		-- if(targetcombat)then targetmobile=targetcombat.owner end
		-- local camera=self.multisidedstrike.environment.cameramanager.camera
		
		if(event.action==TRAININGGROUNDS_JADEFIREMASTERS_CustomDanceEventType.SUCCESS)then
			TRAININGGROUNDS_FakeDBM_RaidBossEmote("Well done!",1.0,true)
			self.successes=self.successes+1
		else
			-- -- not sure about this line...
			--RaidNotice_Clear(RaidBossEmoteFrame)
			local impact=TRAININGGROUNDS_JADEFIREMASTERS_Decor_MSSImpact.new()
			impact:Setup(self.environment)
			impact.x=event.source.owner.x;impact.y=event.source.owner.y;impact.z=event.source.owner.z+yard*2.5	-- conflagrate							
			
		end
	end

	
	
	function class:GetEndOfCycleDelay()
		return 3.0
	end
	
	--TODO: cleanup (and cleanup on base groupdancemodule too?)
	function class:Cleanup()
		--TODO: NYI
	end
end
