local INTRO_TIME_MULTIPLIER=1.0
--local INTRO_TIME_MULTIPLIER=0.1


do
	TRAININGGROUNDS_VECTIS_CustomDanceEventType={}
	local i=0
	i=i+1;TRAININGGROUNDS_VECTIS_CustomDanceEventType.RAVENOUS_BLAZE_TARGETS=i
	i=i+1;TRAININGGROUNDS_VECTIS_CustomDanceEventType.CHECK_FLARE_DISTANCE=i
	
	local super=TRAININGGROUNDS_GroupDanceModule	
	TRAININGGROUNDS_VECTIS_GroupDanceModule_Vectis=TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_VECTIS_GroupDanceModule_Vectis
	
	function class:SetCustomInfo()
		super.SetCustomInfo(self)		
		self.successesinarow=0
		self.playerdead=false		
	end

	local yard=TRAININGGROUNDS_Mobile_ConvertYardsToTGUnits(1)
	local REDX="\124TInterface\\TargetingFrame\\UI-RaidTargetingIcon_7:12\124t"
	
	function class:PopulateDefaultRaid(environment)	
		self.raid:CreatePlayers(environment,0,0,0,1)
		self.raid:MakeAllPlayersIrrelevant()
		
		-- for now, no autoattacks.
		for i=1,#self.raid.players do
			self.raid.players[i].combat.autoattackmodule:Cleanup()
			self.raid.players[i].combat.autoattackmodule=nil
		end
	
		--TODO: move raid roles to another function
		self.tanks=self.raid.tanks
		self.currenttankindex=1
		self.rdps=self.raid.rdps
		self.player=self.raid.rdps[1]
		
		--TODO: set self.wmcontroller during setup
		self.wmcontroller=self.scenario.wmcontroller
		local wmcontroller=self.wmcontroller
							
		self:SetupInitialCameraFocus()
	
	end
	
	--TODO: maybe baseline, maybe not
	function class:SetupInitialCameraFocus()
		local camera=self.vectis.environment.cameramanager.camera
		tinsert(camera.focus,self.player)
		tinsert(camera.focus,self.vectis)	
	end

	
	function class:GetIntoInitialPosition()							
		self.player.x=0
		self.player.y=-15*yard
		self.player.currentfacing=math.pi/2
	end
	
	function class:StartDancing()
		-- TODO: for some reason we're not using this function when we really should be
	end
	
	function class:StartTestCycle()
		--SOURCE: DBM-Core.lua
		 --TimerTracker_OnEvent(TimerTracker, "PLAYER_ENTERING_WORLD")
		 --TimerTracker_OnEvent(TimerTracker, "START_TIMER", 2, 5, 5)
		
		if(self.firsttechnique)then self:SoakChoiceMessage() end
		
		TRAININGGROUNDS_FakeDBM_MinorWarning(DBM,"Starting new Taeshalach Technique...")
		

		--!!!
		local event=TRAININGGROUNDS_TimedDanceEvent.new()
		event.time=self.scenario.localtime+5.0	--!!!
		event.execute=function() 
							self:ResetPlayerDeathChecks()
							--self:StartDancing()
							-- note: target is nil because tankswap() expects vectis to start with no target (or more importantly not target himself)
							TEMP_CastSpellOnTargetMobile(self.vectis,TRAININGGROUNDS_VECTIS_Spell_TaeshalachTechnique,nil)
						end
		tinsert(self.timedevents,event)		
	end
	
	
	function class:ResetPlayerDeathChecks()
		self.playerdead=false
		self.taeshdead=false
	end
	
	
	function class:Step(elapsed)
		super.Step(self,elapsed)
		
		--print(self.localtime)
		for i=#self.timedevents,1,-1 do
			local event=self.timedevents[i]
			if(self.localtime>=event.time)then	
				event.execute()
				tremove(self.timedevents,i)
			end
		end
	end
		
	function class:ReactToCombatEvent(event)
		--TODO: maybe this should be global (but we'd have to call it "TRAININGGROUNDS_yard" instead)
		local yard=TRAININGGROUNDS_Mobile_ConvertYardsToTGUnits(1)		
	
		local targetcombat=event.target
		local targetmobile=nil
		if(targetcombat)then targetmobile=targetcombat.owner end
		local camera=self.vectis.environment.cameramanager.camera
		
		if(event.action==TRAININGGROUNDS_CombatEventType.START_CASTING
		and event.subject==TRAININGGROUNDS_VECTIS_Spell_TaeshalachTechnique)then		
			--
		end
	end
	
	
	function class:GetEndOfCycleDelay()
		return 3.0
	end
	
	--TODO: cleanup (and cleanup on base groupdancemodule too?)
	function class:Cleanup()
		--TODO: NYI
	end
end
